<?php

namespace wp_opieka_globkurier;

class GlobKurierInpost extends GlobKurier{
	protected $productId = 0;
	protected $label = 'PACZKOMAT';
	
	private function _convert( $content ){
		if( ! mb_check_encoding( $content, 'UTF-8' )
		    || ! ( $content === mb_convert_encoding( mb_convert_encoding( $content, 'UTF-32', 'UTF-8' ), 'UTF-8', 'UTF-32' ) ) ){
			$content = mb_convert_encoding( $content, 'UTF-8' );
		}
		
		return $content;
	}
	
	public function getPoints( $paramsIn ){
		
		$function = 'points';
		$method   = 'GET';
		
		$token = $this->api()->getToken();
		$this->getProductId();
		
		// check if inpost code exist
		$params[ 'id' ]        = strtoupper( $this->_convert( $_POST[ 'city' ] ?? '' ) );
		$params[ 'productId' ] = $this->productId;
		
		$response = $this->api()->getResponse( $function, $token, $params, $method );
		
		if( $response[ 'code' ] != 200 || empty( $response[ 'data' ] ) ){
			
			$params = [];
			
			$params[ 'productId' ]                     = $this->productId;
			$params[ 'isCashOnDeliveryAddonSelected' ] = 'false';
			$params[ 'city' ]                          = $this->_convert( $_POST[ 'city' ] ?? '' );
			
			$response = $this->api()->getResponse( $function, $token, $params, $method );
		}
		
		$points = apply_filters( 'globkurier_inpost_points', $response[ 'data' ] );
		
		$pointsResponse = [];
		
		if( $response[ 'code' ] == 200 && count( $response[ 'data' ] ) > 0 ){
			foreach( $points as $point ){
				$pointsResponse[] = [
					'id'           => $point[ 'id' ],
					'label'        => $point[ 'city' ] . ', ' . $point[ 'address' ] . ' [' . $point[ 'id' ] . ']',
					'value'        => $point[ 'city' ] . ', ' . $point[ 'address' ] . ' [' . $point[ 'id' ] . ']',
					'latitude'     => $point[ 'latitude' ],
					'longitude'    => $point[ 'longitude' ],
					'city'         => $point [ 'city' ],
					'address'      => $point [ 'address' ],
					'openingHours' => $point [ 'openingHours' ]
				];
			}
		} else{
			$pointsResponse[] = [
				'id'           => ' ',
				'value'        => ' ',
				'label'        => __( 'Brak wyników', 'globkurier' ),
				'latitude'     => 0,
				'longitude'    => 0,
				'city'         => ' ',
				'address'      => ' ',
				'openingHours' => ' '
			];
		}
		
		return json_encode( $pointsResponse );
		
		do_action( 'globkurier_after_get_inpost_points', $response, $points, $pointsResponse );
		
		return $points;
	}
	
	public function getPointsSelect2( $paramsIn ){
		
		$function = 'points';
		$method   = 'GET';
		
		$token = $this->api()->getToken();
		$this->getProductId();
		
		// check if inpost code exist
		$params[ 'id' ]        = strtoupper( $this->_convert( $paramsIn[ 'city' ] ?? '' ) );
		$params[ 'productId' ] = $this->productId;
		
		$response = $this->api()->getResponse( $function, $token, $params, $method );
		
		if( $response[ 'code' ] != 200 || empty( $response[ 'data' ] ) ){
			
			$params = [];
			
			$params[ 'productId' ]                     = $this->productId;
			$params[ 'isCashOnDeliveryAddonSelected' ] = 'false';
			$params[ 'city' ]                          = $this->_convert( $paramsIn[ 'city' ] ?? '' );
			
			$response = $this->api()->getResponse( $function, $token, $params, $method );
		}
		
		$points = apply_filters( 'globkurier_inpost_points', $response[ 'data' ] );
		
		$pointsResponse = [];
		
		if( $response[ 'code' ] == 200 && count( $response[ 'data' ] ) > 0 ){
			foreach( $points as $point ){
				$pointsResponse[] = [
					'id'           => $point[ 'id' ],
					'label'        => $point[ 'city' ] . ', ' . $point[ 'address' ] . ' [' . $point[ 'id' ] . ']',
					'value'        => $point[ 'city' ] . ', ' . $point[ 'address' ] . ' [' . $point[ 'id' ] . ']',
					'latitude'     => $point[ 'latitude' ],
					'longitude'    => $point[ 'longitude' ],
					'city'         => $point [ 'city' ],
					'address'      => $point [ 'address' ],
					'openingHours' => $point [ 'openingHours' ]
				];
			}
		} else{
//			$pointsResponse[] = [
//				'id'    => ' ',
//				'value' => ' ',
//				'label' => __( 'Brak wyników', 'globkurier' ),
//				'latitude' => 0,
//				'longitude' => 0,
//                'city' => ' ',
//                'address' => ' ',
//                'openingHours' => ' '
//			];
		}
		
		return json_encode( $pointsResponse );
		
		do_action( 'globkurier_after_get_inpost_points', $response, $points, $pointsResponse );
		
		return $points;
	}
	
	public function getAllPoints( $update = FALSE ){
		$oldPoints = get_option( 'gkInPostPoints', NULL );
		
		if( $oldPoints !== NULL && ! $update ){
			return $oldPoints;
		}
		
		$function = 'points';
		$method   = 'GET';
		
//		$token = $this->api()->getToken();
		
		$this->getProductId();
		
		$params = [];
		
		$params[ 'productId' ]                     = $this->productId;
		$params[ 'isCashOnDeliveryAddonSelected' ] = 'false';
		
		$response = $this->api()->getResponse( $function, NULL, $params, $method );
		
		$points = apply_filters( 'globkurier_inpost_points', $response[ 'data' ] );
		
		$pointsResponse = [];
		
		if( $response[ 'code' ] == 200 && count( $response[ 'data' ] ) > 0 ){
			foreach( $points as $point ){
				$pointsResponse[] = [
					'id'           => $point[ 'id' ],
					'label'        => $point[ 'city' ] . ', ' . $point[ 'address' ] . ' [' . $point[ 'id' ] . ']',
					'value'        => $point[ 'city' ] . ', ' . $point[ 'address' ] . ' [' . $point[ 'id' ] . ']',
					'latitude'     => $point[ 'latitude' ],
					'longitude'    => $point[ 'longitude' ],
					'city'         => $point[ 'city' ],
					'address'      => $point[ 'address' ],
					'openingHours' => $point[ 'openingHours' ]
				];
			}
		}
		
		update_option( 'gkInPostPoints', $pointsResponse );
		
		return $pointsResponse;
	}
	
	public function update(){
		$this->getAllPoints( TRUE );
	}
	
	public function getProductId(){
		global $globKurier;
		
		$products = $globKurier->product()->get( [
			'height'                        => '1',
			'width'                         => '1',
			'length'                        => '1',
			'weight'                        => '1',
			'quantity'                      => '1',
			'receiverCountryId'             => '1',
			'receiverPostCode'              => '87-100',
			'senderCountryId'               => '1',
			'senderPostCode'                => '87-100',
			'globkurier_show_all_providers' => 'true',
			'globkurier_is_pickup_active'   => 'true',
			'globkurier_pickup_type'        => '',
		], FALSE );
		
		foreach( $products[ 'results' ] as $product ){
			$labels = array_map('strtolower', $product[ 'labels' ]);
			if( in_array( strtolower($this->label), $labels ) ){
				$this->productId = $product[ 'id' ];
			}
		}
	}
}